Index: sys/sys/mac_private.h
===================================================================
RCS file: mac_private.h
diff -N mac_private.h
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ mac_private.h	Sun Nov 19 17:56:32 2000
@@ -0,0 +1,91 @@
+/*-
+ * Copyright (c) 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Developed by the TrustedBSD Project.
+ * Private label management functions for mandatory security policies.
+ */							
+#ifndef _SYS_MAC_PRIVATE_H
+#define _SYS_MAC_PRIVATE_H
+
+/* Biba Integrity Policy. */
+int     mac_biba_can __P((const struct ucred *cred,
+	    const struct mac *label, int operation, int sub_operation));
+int     mac_biba_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_biba_equal __P((const struct mac *labela,
+	    const struct mac *labelb));
+void    mac_biba_init_subject __P((struct ucred *cred));
+void    mac_biba_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_biba_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_biba_init_object __P((struct mac *label));
+void    mac_biba_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_biba_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_biba_print_label __P((const struct mac *label));
+
+/* Multi-Level Security Policy. */
+int     mac_mls_can __P((const struct ucred *cred, const struct mac *label,
+	    int operation, int sub_operation));
+int     mac_mls_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_mls_equal __P((const struct mac *labela, const struct mac *labelb));
+void    mac_mls_init_subject __P((struct ucred *cred));
+void    mac_mls_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_mls_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_mls_init_object __P((struct mac *label));
+void    mac_mls_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_mls_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_mls_print_label __P((const struct mac *label));
+
+/* Light-Weight Partition Security Policy. */
+int     mac_partition_can __P((const struct ucred *cred,
+	    const struct mac *label, int operation, int sub_operation));
+int     mac_partition_dominate __P((const struct mac *labela,
+	    const struct mac *labelb));
+int     mac_partition_equal __P((const struct mac *labela,
+	    const struct mac *labelb));
+void    mac_partition_init_subject __P((struct ucred *cred));
+void    mac_partition_create_subject __P((const struct ucred *parent_cred,
+	    struct ucred *child_cred));
+int     mac_partition_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void    mac_partition_init_object __P((struct mac *label));
+void    mac_partition_create_object __P((const struct ucred *cred,
+	    struct mac *label));
+int     mac_partition_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_partition_print_label __P((const struct mac *label));
+
+#endif /* !_SYS_MAC_PRIVATE_H */
Index: sys/sys/mbuf.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mbuf.h,v
retrieving revision 1.84
diff -u -r1.84 mbuf.h
--- sys/sys/mbuf.h	2001/08/19 04:35:26	1.84
+++ sys/sys/mbuf.h	2001/09/13 16:43:15
@@ -85,6 +85,7 @@
 	int	csum_flags;		/* flags regarding checksum */
 	int	csum_data;		/* data field used by csum routines */
 	struct	mbuf *aux;		/* extra data buffer; ipsec/others */
+	struct	mac label;		/* label of data in packet */
 };
 
 /*
Index: sys/sys/mount.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mount.h,v
retrieving revision 1.113
diff -u -r1.113 mount.h
--- sys/sys/mount.h	2001/09/12 08:38:05	1.113
+++ sys/sys/mount.h	2001/09/13 22:02:59
@@ -43,6 +43,7 @@
  */
 #include <sys/lockmgr.h>
 
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/queue.h>
 #ifdef _KERNEL
Index: sys/sys/proc.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/proc.h,v
retrieving revision 1.184
diff -u -r1.184 proc.h
--- sys/sys/proc.h	2001/09/18 21:03:53	1.184
+++ sys/sys/proc.h	2001/09/19 02:40:32
@@ -53,6 +53,7 @@
 #ifndef _KERNEL
 #include <sys/time.h>			/* For structs itimerval, timeval. */
 #endif
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <machine/proc.h>		/* Machine-dependent proc substruct. */
 
Index: sys/sys/ucred.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/ucred.h,v
retrieving revision 1.25
diff -u -r1.25 ucred.h
--- sys/sys/ucred.h	2001/09/12 08:38:06	1.25
+++ sys/sys/ucred.h	2001/09/13 22:03:02
@@ -59,6 +59,9 @@
 	struct	uidinfo *cr_uidinfo;	/* per euid resource consumption */
 	struct	uidinfo *cr_ruidinfo;	/* per ruid resource consumption */
 	struct	prison *cr_prison;	/* jail(4) */
+#ifdef MAC
+	struct	mac cr_label;		/* mandatory access control label */
+#endif
 	struct	mtx cr_mtx;		/* protect refcount */
 };
 #define cr_gid cr_groups[0]
@@ -76,6 +79,7 @@
 	short	cr_ngroups;		/* number of groups */
 	gid_t	cr_groups[NGROUPS];	/* groups */
 	void	*_cr_unused1;		/* compatibility with old ucred */
+	struct	mac cr_label;		/* mandatory access control label */
 };
 
 #ifdef _KERNEL
Index: sys/sys/user.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/user.h,v
retrieving revision 1.44
diff -u -r1.44 user.h
--- sys/sys/user.h	2001/09/13 22:52:41	1.44
+++ sys/sys/user.h	2001/09/19 02:40:39
@@ -43,6 +43,7 @@
 #include <sys/errno.h>
 #include <sys/time.h>
 #include <sys/resource.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/_lock.h>
Index: sys/sys/vnode.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/vnode.h,v
retrieving revision 1.157
diff -u -r1.157 vnode.h
--- sys/sys/vnode.h	2001/09/13 22:52:42	1.157
+++ sys/sys/vnode.h	2001/09/19 02:40:40
@@ -543,6 +543,7 @@
 struct proc;
 struct stat;
 struct nstat;
+struct mac;
 struct ucred;
 struct uio;
 struct vattr;
@@ -574,6 +575,8 @@
 int	vaccess_acl_posix1e __P((enum vtype type, uid_t file_uid,
 	    gid_t file_gid, struct acl *acl, mode_t acc_mode,
 	    struct ucred *cred, int *privused));
+int	vaccess_mac __P((enum vtype type, const struct mac *filelabel,
+	    mode_t acc_mode, struct ucred *cred, int *privused));
 void	vattr_null __P((struct vattr *vap));
 int	vcount __P((struct vnode *vp));
 void	vdrop __P((struct vnode *));
cvs diff: Diffing sys/ufs
cvs diff: Diffing sys/ufs/ffs
Index: sys/ufs/ffs/ffs_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_vfsops.c,v
retrieving revision 1.160
diff -u -r1.160 ffs_vfsops.c
--- sys/ufs/ffs/ffs_vfsops.c	2001/09/12 08:38:07	1.160
+++ sys/ufs/ffs/ffs_vfsops.c	2001/09/13 22:03:03
@@ -34,6 +34,7 @@
  * $FreeBSD: src/sys/ufs/ffs/ffs_vfsops.c,v 1.160 2001/09/12 08:38:07 julian Exp $
  */
 
+#include "opt_mac.h"
 #include "opt_quota.h"
 #include "opt_ufs.h"
 
@@ -712,6 +713,18 @@
 		ump->um_quotas[i] = NULLVP;
 #ifdef UFS_EXTATTR
 	ufs_extattr_uepm_init(&ump->um_extattr);
+#endif
+#ifdef MAC
+	/*
+	 * The following sets a file system to use default object labels
+	 * for system objects.
+	 *	 mac_init_object(&ump->um_label);
+	 */
+	/* The following inherits a file system label from the credential
+	 * of the caller.  mac_inherit_object knows what to do if cred is
+	 * NOCRED.
+	 */
+	mac_create_object(cred, &ump->um_label);
 #endif
 	devvp->v_rdev->si_mountpoint = mp;
 	ffs_oldfscompat(fs);
cvs diff: Diffing sys/ufs/ifs
cvs diff: Diffing sys/ufs/ufs
Index: sys/ufs/ufs/ufs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_vnops.c,v
retrieving revision 1.173
diff -u -r1.173 ufs_vnops.c
--- sys/ufs/ufs/ufs_vnops.c	2001/09/12 08:38:10	1.173
+++ sys/ufs/ufs/ufs_vnops.c	2001/09/13 22:03:06
@@ -39,6 +39,7 @@
  * $FreeBSD: src/sys/ufs/ufs/ufs_vnops.c,v 1.173 2001/09/12 08:38:10 julian Exp $
  */
 
+#include "opt_mac.h"
 #include "opt_quota.h"
 #include "opt_suiddir.h"
 #include "opt_ufs.h"
@@ -60,6 +61,7 @@
 #include <sys/event.h>
 #include <sys/conf.h>
 #include <sys/acl.h>
+#include <sys/mac.h>
 
 #include <machine/mutex.h>
 
@@ -88,6 +90,9 @@
 static int ufs_close __P((struct vop_close_args *));
 static int ufs_create __P((struct vop_create_args *));
 static int ufs_getattr __P((struct vop_getattr_args *));
+#ifdef MAC
+static int ufs_getlabel __P((struct vop_getlabel_args *));
+#endif
 static int ufs_link __P((struct vop_link_args *));
 static int ufs_makeinode __P((int mode, struct vnode *, struct vnode **, struct componentname *));
 static int ufs_missingop __P((struct vop_generic_args *ap));
@@ -101,6 +106,9 @@
 static int ufs_rename __P((struct vop_rename_args *));
 static int ufs_rmdir __P((struct vop_rmdir_args *));
 static int ufs_setattr __P((struct vop_setattr_args *));
+#ifdef MAC
+static int ufs_setlabel __P((struct vop_setlabel_args *));
+#endif
 static int ufs_strategy __P((struct vop_strategy_args *));
 static int ufs_symlink __P((struct vop_symlink_args *));
 static int ufs_whiteout __P((struct vop_whiteout_args *));
@@ -337,6 +345,9 @@
 {
 	struct vnode *vp = ap->a_vp;
 	struct inode *ip = VTOI(vp);
+#ifdef MAC
+	struct mac label;
+#endif
 	mode_t mode = ap->a_mode;
 	int error;
 #ifdef UFS_ACL
@@ -367,9 +378,26 @@
 	}
 
 	/* If immutable bit set, nobody gets to write it. */
+	/* XXX: This breaks chflags(), please fix.
+	if ((mode & (VWRITE | VADMIN)) &&
+	    (ip->i_flags & (IMMUTABLE | SF_SNAPSHOT)))
+		return (EPERM);
+	*/
 	if ((mode & VWRITE) && (ip->i_flags & (IMMUTABLE | SF_SNAPSHOT)))
 		return (EPERM);
 
+#ifdef MAC
+	error = VOP_GETLABEL(vp, &label, ap->a_cred, ap->a_p);
+	if (error) {
+		printf("ufs_access: couldn't get any label (%d)\n", error);
+		return (error);
+	}
+	error = vaccess_mac(vp->v_type, &label, ap->a_mode, ap->a_cred, NULL);
+	if (error) {
+		printf("mac_vaccess returned %d\n", error);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	MALLOC(acl, struct acl *, sizeof(*acl), M_ACL, M_WAITOK);
 	len = sizeof(*acl);
@@ -738,6 +766,101 @@
 	return (0);
 }
 
+#ifdef MAC
+/*
+ * Retrieve the MAC label on a file.
+ */
+static int
+ufs_getlabel(ap)
+	struct vop_getlabel_args /* {
+		struct vnode *a_vp;
+		struct mac *a_label;
+		struct ucred *a_cred;
+		struct proc *a_p;
+	} */ *ap;
+{
+	struct ufsmount *ump;
+	int error, len;
+
+	len = sizeof(*ap->a_label);
+	bzero(ap->a_label, sizeof(*ap->a_label));
+	error = vn_extattr_get(ap->a_vp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAME, &len, (char *) ap->a_label, ap->a_p);
+	switch (error) {
+	case 0:
+		/*
+		 * Successfully retrieved the label from disk.
+		 * Check the length, fail closed.
+		 */
+		if (len != sizeof(*ap->a_label)) {
+			printf("Corrupted label\n");
+			error = EPERM;
+		}
+		break;
+	case ENOENT:    /* XXX: Should be ENOATTR not ENOENT. */
+	case EOPNOTSUPP:
+		/*
+		 * If no label is available, return the mount label
+		 * instead.
+		 */
+		ump = VFSTOUFS(ap->a_vp->v_mount);
+		*ap->a_label = ump->um_label;
+		error = 0;
+		break;
+	default:
+	}
+
+	return (error);
+}
+
+/*
+ * Set the MAC label on a file.
+ */
+static int
+ufs_setlabel(ap)
+	struct vop_setlabel_args /* {
+		struct vnode *a_vp;
+		struct mac *a_label;
+		struct ucred *a_cred;
+		struct proc *a_p;
+	} */ *ap;
+{
+	struct mac old_label;
+	int error;
+
+	/*
+	 * First access check: does the caller have the ability to
+	 * administer the file system object to be labeled/re-labeled.
+	 */
+	error = VOP_ACCESS(ap->a_vp, VADMIN, ap->a_cred, ap->a_p);
+	if (error)
+		return (error);
+
+	/*
+	 * Second check: is the label being assigned to the object
+	 * appropriate based on the label previously assigned, and
+	 * the label on the subject.  To do this, must retrieve the
+	 * old label.
+	 */
+	error = VOP_GETLABEL(ap->a_vp, &old_label, ap->a_cred, ap->a_p);
+	if (error)
+		return (error);
+
+	error = mac_can_setlabel_object(ap->a_cred, &old_label, ap->a_label);
+	if (error)
+		return (error);
+
+	error = vn_extattr_set(ap->a_vp, IO_NODELOCKED,
+	    FREEBSD_MAC_EXTATTR_NAME, sizeof(*ap->a_label),
+	    (char *) ap->a_label, ap->a_p);
+	if (error)
+		return (error);
+	
+	VN_KNOTE(ap->a_vp, NOTE_ATTRIB);
+	return (0);
+}
+#endif /* !MAC */
+
 int
 ufs_remove(ap)
 	struct vop_remove_args /* {
@@ -1340,6 +1463,10 @@
 	struct buf *bp;
 	struct dirtemplate dirtemplate, *dtp;
 	struct direct newdir;
+#ifdef MAC
+	struct ufsmount *ump;
+	struct mac label;
+#endif
 #ifdef UFS_ACL
 	struct acl *acl, *dacl;
 #endif
@@ -1493,6 +1620,30 @@
 	error = UFS_UPDATE(tvp, !(DOINGSOFTDEP(dvp) | DOINGASYNC(dvp)));
 	if (error)
 		goto bad;
+
+#ifdef MAC
+	mac_create_object(cnp->cn_cred, &label);
+	error = vn_extattr_set(tvp, IO_NODELOCKED, FREEBSD_MAC_EXTATTR_NAME,
+	    sizeof(label), (char *) &label, cnp->cn_proc);
+	switch (error) {
+	case 0:
+		break;
+	case ENOENT: /* XXX: Should be ENOATTR. */
+	case EOPNOTSUPP:
+		/* Authorize creation of a file with the device label. */
+		ump = VFSTOUFS(tvp->v_mount);
+		error = mac_can(cnp->cn_cred, &ump->um_label, MAC_CREATE, 0);
+		if (error == 0)
+			break;
+		printf("ufs_mkdir: cannot assign MAC or use default\n");
+		/* Falls through. */
+	default:
+		printf("ufs_mkdir failed (%d)\n", error);
+		UFS_VFREE(tvp, ip->i_number, dmode);
+		vput(tvp);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	if (acl != NULL) {
 		/*
@@ -2229,6 +2380,10 @@
 	register struct inode *ip, *pdir;
 	struct direct newdir;
 	struct vnode *tvp;
+#ifdef MAC
+	struct ufsmount *ump;
+	struct mac label;
+#endif
 #ifdef UFS_ACL
 	struct acl *acl;
 #endif
@@ -2365,6 +2520,34 @@
 	error = UFS_UPDATE(tvp, !(DOINGSOFTDEP(tvp) | DOINGASYNC(tvp)));
 	if (error)
 		goto bad;
+/*
+ * Set the MAC label for the newly created file.  Attempt to set it using
+ * the credential of the writer; if this is not allowed, check to see if
+ * the writer has the same label as the default file system label.  If neither
+ * succeeds, then fail closed.
+ */
+#ifdef MAC
+	mac_create_object(cnp->cn_cred, &label);
+	error = vn_extattr_set(tvp, IO_NODELOCKED, FREEBSD_MAC_EXTATTR_NAME,
+	    sizeof(label), (char *) &label, cnp->cn_proc);
+	switch (error) {
+	case 0:
+	break;
+	case ENOENT: /* XXX: should be ENOATTR. */
+	case EOPNOTSUPP:
+		/* Authorize creation of a file with the device label. */
+		ump = VFSTOUFS(tvp->v_mount);
+		error = mac_can(cnp->cn_cred, &ump->um_label, MAC_CREATE, 0);
+		if (error == 0)
+			break;
+		/* Falls through. */
+	default:
+		printf("ufs_makeinode failed (%d)\n", error);
+		UFS_VFREE(tvp, ip->i_number, mode);
+		vput(tvp);
+		return (error);
+	}
+#endif /* !MAC */
 #ifdef UFS_ACL
 	if (acl != NULL) {
 		/*
@@ -2540,6 +2723,9 @@
 	{ &vop_close_desc,		(vop_t *) ufs_close },
 	{ &vop_create_desc,		(vop_t *) ufs_create },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif MAC
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_link_desc,		(vop_t *) ufs_link },
@@ -2560,6 +2746,9 @@
 	{ &vop_rename_desc,		(vop_t *) ufs_rename },
 	{ &vop_rmdir_desc,		(vop_t *) ufs_rmdir },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_strategy_desc,		(vop_t *) ufs_strategy },
 	{ &vop_symlink_desc,		(vop_t *) ufs_symlink },
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
@@ -2581,6 +2770,9 @@
 	{ &vop_access_desc,		(vop_t *) ufs_access },
 	{ &vop_close_desc,		(vop_t *) ufsspec_close },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_lock_desc,		(vop_t *) vop_stdlock },
@@ -2588,6 +2780,9 @@
 	{ &vop_read_desc,		(vop_t *) ufsspec_read },
 	{ &vop_reclaim_desc,		(vop_t *) ufs_reclaim },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
 	{ &vop_write_desc,		(vop_t *) ufsspec_write },
 #ifdef UFS_ACL
@@ -2607,6 +2802,9 @@
 	{ &vop_access_desc,		(vop_t *) ufs_access },
 	{ &vop_close_desc,		(vop_t *) ufsfifo_close },
 	{ &vop_getattr_desc,		(vop_t *) ufs_getattr },
+#ifdef MAC
+	{ &vop_getlabel_desc,		(vop_t *) ufs_getlabel },
+#endif
 	{ &vop_inactive_desc,		(vop_t *) ufs_inactive },
 	{ &vop_islocked_desc,		(vop_t *) vop_stdislocked },
 	{ &vop_kqfilter_desc,		(vop_t *) ufsfifo_kqfilter },
@@ -2615,6 +2813,9 @@
 	{ &vop_read_desc,		(vop_t *) ufsfifo_read },
 	{ &vop_reclaim_desc,		(vop_t *) ufs_reclaim },
 	{ &vop_setattr_desc,		(vop_t *) ufs_setattr },
+#ifdef MAC
+	{ &vop_setlabel_desc,		(vop_t *) ufs_setlabel },
+#endif
 	{ &vop_unlock_desc,		(vop_t *) vop_stdunlock },
 	{ &vop_write_desc,		(vop_t *) ufsfifo_write },
 #ifdef UFS_ACL
Index: sys/ufs/ufs/ufsmount.h
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufsmount.h,v
retrieving revision 1.22
diff -u -r1.22 ufsmount.h
--- sys/ufs/ufs/ufsmount.h	2001/09/12 08:38:11	1.22
+++ sys/ufs/ufs/ufsmount.h	2001/09/13 22:03:06
@@ -77,6 +77,7 @@
 	struct	vnode *um_quotas[MAXQUOTAS];	/* pointer to quota files */
 	struct	ucred *um_cred[MAXQUOTAS];	/* quota file access cred */
 	struct	ufs_extattr_per_mount um_extattr;	/* extended attrs */
+	struct	mac um_label;			/* immutable mounter label */
 	u_long	um_nindir;			/* indirect ptrs per block */
 	u_long	um_bptrtodb;			/* indir ptr to disk block */
 	u_long	um_seqinc;			/* inc between seq blocks */
cvs diff: Diffing sys/vm
cvs diff: Diffing tools
cvs diff: Diffing tools/3.0-upgrade
cvs diff: Diffing tools/LibraryReport
cvs diff: Diffing tools/diag
cvs diff: Diffing tools/diag/ac
cvs diff: Diffing tools/diag/dumpvfscache
cvs diff: Diffing tools/diag/httpd-error
cvs diff: Diffing tools/regression
cvs diff: Diffing tools/regression/nfsmmap
cvs diff: Diffing tools/regression/nfsmmap/test1
cvs diff: Diffing tools/regression/nfsmmap/test2
cvs diff: Diffing tools/regression/p1003_1b
cvs diff: Diffing tools/regression/security
cvs diff: Diffing tools/regression/security/access
cvs diff: Diffing tools/regression/security/proc_to_proc
cvs diff: Diffing tools/test
cvs diff: Diffing tools/test/devrandom
cvs diff: Diffing tools/test/malloc
cvs diff: Diffing tools/test/posixshm
cvs diff: Diffing tools/tools
cvs diff: Diffing tools/tools/editing
cvs diff: Diffing tools/tools/epfe
cvs diff: Diffing tools/tools/html-mv
cvs diff: Diffing tools/tools/ifinfo
cvs diff: Diffing tools/tools/kdrv
cvs diff: Diffing tools/tools/kerninclude
cvs diff: Diffing tools/tools/kernxref
cvs diff: Diffing tools/tools/mid
cvs diff: Diffing tools/tools/portsinfo
cvs diff: Diffing tools/tools/scsi-defects
cvs diff: Diffing tools/tools/tcl_bmake
cvs diff: Diffing tools/tools/upgrade
cvs diff: Diffing tools/tools/vop_table
cvs diff: Diffing usr.bin
cvs diff: Diffing usr.bin/apply
cvs diff: Diffing usr.bin/ar
cvs diff: Diffing usr.bin/at
cvs diff: Diffing usr.bin/banner
cvs diff: Diffing usr.bin/basename
cvs diff: Diffing usr.bin/biff
cvs diff: Diffing usr.bin/brandelf
cvs diff: Diffing usr.bin/bzip2
cvs diff: Diffing usr.bin/bzip2/doc
cvs diff: Diffing usr.bin/c89
cvs diff: Diffing usr.bin/calendar
cvs diff: Diffing usr.bin/calendar/calendars
cvs diff: Diffing usr.bin/calendar/calendars/de_DE.ISO8859-1
cvs diff: Diffing usr.bin/calendar/calendars/hr_HR.ISO8859-2
cvs diff: Diffing usr.bin/calendar/calendars/ru_RU.KOI8-R
cvs diff: Diffing usr.bin/cap_mkdb
cvs diff: Diffing usr.bin/chat
cvs diff: Diffing usr.bin/checknr
cvs diff: Diffing usr.bin/chflags
cvs diff: Diffing usr.bin/chkey
cvs diff: Diffing usr.bin/chpass
cvs diff: Diffing usr.bin/cksum
cvs diff: Diffing usr.bin/cmp
cvs diff: Diffing usr.bin/col
cvs diff: Diffing usr.bin/colcrt
cvs diff: Diffing usr.bin/colldef
cvs diff: Diffing usr.bin/colrm
cvs diff: Diffing usr.bin/column
cvs diff: Diffing usr.bin/comm
cvs diff: Diffing usr.bin/compile_et
cvs diff: Diffing usr.bin/compress
cvs diff: Diffing usr.bin/compress/doc
cvs diff: Diffing usr.bin/ctags
cvs diff: Diffing usr.bin/ctags/test
cvs diff: Diffing usr.bin/cut
cvs diff: Diffing usr.bin/dig
cvs diff: Diffing usr.bin/dirname
cvs diff: Diffing usr.bin/dnskeygen
cvs diff: Diffing usr.bin/dnsquery
cvs diff: Diffing usr.bin/doscmd
cvs diff: Diffing usr.bin/du
cvs diff: Diffing usr.bin/ee
cvs diff: Diffing usr.bin/ee/nls
cvs diff: Diffing usr.bin/ee/nls/de_DE.ISO8859-1
cvs diff: Diffing usr.bin/ee/nls/en_US.US-ASCII
cvs diff: Diffing usr.bin/ee/nls/fr_FR.ISO8859-1
cvs diff: Diffing usr.bin/ee/nls/pl_PL.ISO8859-2
cvs diff: Diffing usr.bin/ee/nls/ru_RU.KOI8-R
cvs diff: Diffing usr.bin/ee/nls/uk_UA.KOI8-U
cvs diff: Diffing usr.bin/enigma
cvs diff: Diffing usr.bin/env
cvs diff: Diffing usr.bin/expand
cvs diff: Diffing usr.bin/false
cvs diff: Diffing usr.bin/fetch
cvs diff: Diffing usr.bin/file
cvs diff: Diffing usr.bin/file2c
cvs diff: Diffing usr.bin/find
Index: usr.bin/find/function.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/find/function.c,v
retrieving revision 1.35
diff -u -r1.35 function.c
--- usr.bin/find/function.c	2001/09/14 13:42:26	1.35
+++ usr.bin/find/function.c	2001/09/19 02:42:08
@@ -44,6 +44,7 @@
 #endif /* not lint */
 
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/stat.h>
 #include <sys/wait.h>
cvs diff: Diffing usr.bin/finger
cvs diff: Diffing usr.bin/fmt
cvs diff: Diffing usr.bin/fold
cvs diff: Diffing usr.bin/from
cvs diff: Diffing usr.bin/fstat
cvs diff: Diffing usr.bin/fsync
cvs diff: Diffing usr.bin/ftp
cvs diff: Diffing usr.bin/gcore
cvs diff: Diffing usr.bin/gencat
cvs diff: Diffing usr.bin/getconf
cvs diff: Diffing usr.bin/getopt
cvs diff: Diffing usr.bin/gprof
cvs diff: Diffing usr.bin/gprof/PSD.doc
cvs diff: Diffing usr.bin/gprof4
cvs diff: Diffing usr.bin/head
cvs diff: Diffing usr.bin/hesinfo
cvs diff: Diffing usr.bin/hexdump
cvs diff: Diffing usr.bin/host
cvs diff: Diffing usr.bin/id
cvs diff: Diffing usr.bin/indent
cvs diff: Diffing usr.bin/ipcrm
cvs diff: Diffing usr.bin/ipcs
cvs diff: Diffing usr.bin/join
cvs diff: Diffing usr.bin/jot
cvs diff: Diffing usr.bin/kdump
cvs diff: Diffing usr.bin/kenv
cvs diff: Diffing usr.bin/keylogin
cvs diff: Diffing usr.bin/keylogout
cvs diff: Diffing usr.bin/killall
cvs diff: Diffing usr.bin/ktrace
cvs diff: Diffing usr.bin/lam
cvs diff: Diffing usr.bin/last
cvs diff: Diffing usr.bin/lastcomm
cvs diff: Diffing usr.bin/ldd
cvs diff: Diffing usr.bin/leave
cvs diff: Diffing usr.bin/less
cvs diff: Diffing usr.bin/lessecho
cvs diff: Diffing usr.bin/lesskey
cvs diff: Diffing usr.bin/lex
cvs diff: Diffing usr.bin/lex/lib
cvs diff: Diffing usr.bin/limits
cvs diff: Diffing usr.bin/locate
cvs diff: Diffing usr.bin/locate/bigram
cvs diff: Diffing usr.bin/locate/code
cvs diff: Diffing usr.bin/locate/locate
cvs diff: Diffing usr.bin/lock
cvs diff: Diffing usr.bin/lockf
cvs diff: Diffing usr.bin/logger
cvs diff: Diffing usr.bin/login
Index: usr.bin/login/login.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/login/login.c,v
retrieving revision 1.69
diff -u -r1.69 login.c
--- usr.bin/login/login.c	2001/09/15 17:09:39	1.69
+++ usr.bin/login/login.c	2001/09/19 03:14:23
@@ -394,7 +394,13 @@
 	lc = login_getpwclass(pwd);
 
 	quietlog = login_getcapbool(lc, "hushlogin", 0);
+#if 0
 	/*
+	 * XXX: The sete[ug]id code here is broken in the base system
+	 * because it doesn't do setgroups().  It's even more broken
+	 * with MAC.  This test needs to happen further down, below
+	 * the setusercontext call.
+	 *
 	 * Switching needed for NFS with root access disabled.
 	 *
 	 * XXX: This change fails to modify the additional groups for the
@@ -414,6 +420,7 @@
 	}
 	(void)seteuid(euid);
 	(void)setegid(egid);
+#endif
 	if (!quietlog)
 		quietlog = access(_PATH_HUSHLOGIN, F_OK) == 0;
 
@@ -630,6 +637,22 @@
                 syslog(LOG_ERR, "setusercontext() failed - exiting");
 		exit(1);
 	}
+
+#if 1
+	/*
+	 * XXX: The home directory check should really go here, after
+	 * credentials are appropriately configured.
+	 */
+	if (!*pwd->pw_dir || chdir(pwd->pw_dir) < 0) {
+		if (login_getcapbool(lc, "requirehome", 0))
+			refused("Home directory not available", "HOMEDIR", 1);
+		if (chdir("/") < 0)
+			refused("Cannot find root directory", "ROOTDIR", 1);
+		if (!quietlog || *pwd->pw_dir)
+			printf("No home directory.\nLogging in with home = \"/\".\n");
+		pwd->pw_dir = "/";
+	}
+#endif
 
 	(void)setenv("SHELL", pwd->pw_shell, 1);
 	(void)setenv("HOME", pwd->pw_dir, 1);
cvs diff: Diffing usr.bin/logname
cvs diff: Diffing usr.bin/look
cvs diff: Diffing usr.bin/lorder
cvs diff: Diffing usr.bin/lsvfs
cvs diff: Diffing usr.bin/m4
cvs diff: Diffing usr.bin/m4/TEST
cvs diff: Diffing usr.bin/mail
cvs diff: Diffing usr.bin/mail/USD.doc
cvs diff: Diffing usr.bin/mail/misc
cvs diff: Diffing usr.bin/make
cvs diff: Diffing usr.bin/make/PSD.doc
cvs diff: Diffing usr.bin/make/lst.lib
cvs diff: Diffing usr.bin/mesg
cvs diff: Diffing usr.bin/minigzip
cvs diff: Diffing usr.bin/mkdep
cvs diff: Diffing usr.bin/mkfifo
cvs diff: Diffing usr.bin/mklocale
cvs diff: Diffing usr.bin/mkstr
cvs diff: Diffing usr.bin/mktemp
cvs diff: Diffing usr.bin/msgs
cvs diff: Diffing usr.bin/mt
cvs diff: Diffing usr.bin/ncal
cvs diff: Diffing usr.bin/ncplist
cvs diff: Diffing usr.bin/ncplogin
cvs diff: Diffing usr.bin/netstat
cvs diff: Diffing usr.bin/newkey
cvs diff: Diffing usr.bin/nfsstat
cvs diff: Diffing usr.bin/nice
cvs diff: Diffing usr.bin/nl
cvs diff: Diffing usr.bin/nm
cvs diff: Diffing usr.bin/nohup
cvs diff: Diffing usr.bin/objformat
cvs diff: Diffing usr.bin/opieinfo
cvs diff: Diffing usr.bin/opiekey
cvs diff: Diffing usr.bin/opiepasswd
cvs diff: Diffing usr.bin/pagesize
cvs diff: Diffing usr.bin/passwd
Index: usr.bin/passwd/Makefile
===================================================================
RCS file: /home/ncvs/src/usr.bin/passwd/Makefile,v
retrieving revision 1.42
diff -u -r1.42 Makefile
--- usr.bin/passwd/Makefile	2001/09/13 06:48:17	1.42
+++ usr.bin/passwd/Makefile	2001/09/19 02:43:35
@@ -32,7 +32,7 @@
 CFLAGS+=-Wall
 
 DPADD=	${LIBCRYPT} ${LIBRPCSVC} ${LIBUTIL}
-LDADD=	-lcrypt -lrpcsvc -lutil
+LDADD=	-lcrypt -lrpcsvc -lutil -lposix1e
 .PATH:  ${.CURDIR}/../../usr.bin/chpass ${.CURDIR}/../../usr.sbin/vipw \
 	${.CURDIR}/../rlogin ${.CURDIR}/../../libexec/ypxfr \
 	${.CURDIR}/../../usr.sbin/rpc.yppasswdd
@@ -44,7 +44,10 @@
 	-I${.CURDIR}/../../usr.sbin/rpc.yppasswdd \
 	-Dyp_error=warnx -DLOGGING
 
+.if defined(MAC)
+CFLAGS+=-DMAC
 .endif
+.endif
 
 CLEANFILES= ${GENSRCS}
 
@@ -88,7 +91,7 @@
 CFLAGS+=	-DKERBEROS
 # XXX not defined: ${LIBKADM}, ${LIBCOM_ERR}
 DPADD=	${LIBKADM} ${LIBKRB} ${LIBCRYPTO} ${LIBCRYPT} ${LIBRPCSVC} ${LIBCOM_ERR} ${LIBUTIL}
-LDADD=	-lkadm -lkrb -lcrypto -lcrypt -lrpcsvc -lcom_err -lutil
+LDADD=	-lkadm -lkrb -lcrypto -lcrypt -lrpcsvc -lcom_err -lutil -lposix1e
 DISTRIBUTION=	krb4
 .endif
 
Index: usr.bin/passwd/local_passwd.c
===================================================================
RCS file: /home/ncvs/src/usr.bin/passwd/local_passwd.c,v
retrieving revision 1.27
diff -u -r1.27 local_passwd.c
--- usr.bin/passwd/local_passwd.c	2001/03/11 16:37:30	1.27
+++ usr.bin/passwd/local_passwd.c	2001/05/31 14:50:00
@@ -39,6 +39,9 @@
 
 #include <sys/types.h>
 #include <sys/time.h>
+#ifdef MAC
+#include <sys/mac.h>
+#endif
 
 #include <ctype.h>
 #include <err.h>
@@ -70,6 +73,9 @@
 #include "extern.h"
 
 static uid_t uid;
+#ifdef MAC
+static mac_t label;
+#endif
 int randinit;
 
 char   *tempname;
@@ -208,6 +214,13 @@
 	uid = getuid();
 	if (uid && uid != pw->pw_uid)
 		errx(1, "%s", strerror(EACCES));
+#ifdef MAC
+	label = mac_get_proc();
+	if (label == NULL)
+		err(1, "mac_get_proc");
+	if (mac_set_proc(&mac_userland_system_high_label) == -1)
+		err(1, "mac_set_proc");
+#endif
 
 	pw_init();
 
cvs diff: Diffing usr.bin/paste
cvs diff: Diffing usr.bin/pr
cvs diff: Diffing usr.bin/printenv
cvs diff: Diffing usr.bin/printf
cvs diff: Diffing usr.bin/quota
cvs diff: Diffing usr.bin/ranlib
cvs diff: Diffing usr.bin/renice
cvs diff: Diffing usr.bin/rev
cvs diff: Diffing usr.bin/rlogin
cvs diff: Diffing usr.bin/rpcgen
cvs diff: Diffing usr.bin/rpcinfo
cvs diff: Diffing usr.bin/rs
cvs diff: Diffing usr.bin/rsh
cvs diff: Diffing usr.bin/rup
cvs diff: Diffing usr.bin/ruptime
cvs diff: Diffing usr.bin/rusers
cvs diff: Diffing usr.bin/rwall
cvs diff: Diffing usr.bin/rwho
cvs diff: Diffing usr.bin/sasc
cvs diff: Diffing usr.bin/script
Index: usr.bin/script/Makefile
===================================================================
RCS file: /home/ncvs/src/usr.bin/script/Makefile,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 Makefile
--- usr.bin/script/Makefile	1994/05/27 12:32:38	1.1.1.1
+++ usr.bin/script/Makefile	2000/11/20 06:13:44
@@ -1,7 +1,7 @@
 #	@(#)Makefile	8.1 (Berkeley) 6/6/93
 
 PROG=	script
-LDADD=	-lutil
+LDADD=	-lutil -lposix1e
 DPADD=	${LIBUTIL}
 
 .include <bsd.prog.mk>
cvs diff: Diffing usr.bin/sed
cvs diff: Diffing usr.bin/sed/TEST
cvs diff: Diffing usr.bin/shar
cvs diff: Diffing usr.bin/showmount
cvs diff: Diffing usr.bin/size
cvs diff: Diffing usr.bin/sockstat
cvs diff: Diffing usr.bin/soelim
cvs diff: Diffing usr.bin/split
cvs diff: Diffing usr.bin/strings
cvs diff: Diffing usr.bin/strip
cvs diff: Diffing usr.bin/su
cvs diff: Diffing usr.bin/symorder
cvs diff: Diffing usr.bin/systat
cvs diff: Diffing usr.bin/tail
cvs diff: Diffing usr.bin/talk
cvs diff: Diffing usr.bin/tconv
cvs diff: Diffing usr.bin/tcopy
cvs diff: Diffing usr.bin/tee
cvs diff: Diffing usr.bin/telnet
cvs diff: Diffing usr.bin/tftp
cvs diff: Diffing usr.bin/time
cvs diff: Diffing usr.bin/tip
cvs diff: Diffing usr.bin/tip/libacu
cvs diff: Diffing usr.bin/tip/tip
